/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : bobyor1
Version : 
Date    : 03.12.2015
Author  : 
Company : 
Comments: 


Chip type               : ATmega88A
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega88a.h>

#include <delay.h>

// Alphanumeric LCD Module functions
#include <alcd.h>

eeprom char volstore;
eeprom unsigned int correctl, correctr;
char encoder_state,zamer[2],falltime[2];
volatile signed char encoder_pos;
signed char j,volume,vol2;
//char lin[2];
int voltime,del,volcor[2];
char cyfh,cyfm,cyfl,girno,polu,nichego,dela;
flash char merka[30]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,18,20,24,29,33,39,46,54,63,74,87,102,120};
flash char bukvy[16]={0x79,0x63,0xb8,0xbb,0xb8,0xbf,0x65,0xbb,0xc4,6,0,6,1,7,0x2d,2};
flash char x[16]={6,10,8,7,5,11,8,4,10,5,9,6,9,12,7,11};
flash char y[16]={1, 0,0,1,0, 0,1,0, 1,1,0,0,1, 0,0, 1};
 int  corr[2];
bit krut,channel,on=0; 
flash char znakog[64]={
// O 
0b00011110,
0b00001001,
0b00001001,
0b00001001,
0b00001001,
0b00001001,
0b00000111,
0b00000000,
// 
0b00010010,
0b00001111,
0b00001000,
0b00001100,
0b00001010,
0b00001000,
0b00010111,
0b00000000,
// 1
0b00011000,
0b00001000,
0b00001000,
0b00001000,
0b00001000,
0b00001000,
0b00010100,
0b00000000,
// -
0b00000000,
0b00000000,
0b00000000,
0b00011011,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
//  
0b00011011,
0b00011011,
0b00011011,
0b00011011,
0b00011011,
0b00011011,
0b00011011,
0b00000000,
//  
0b00011000,
0b00011000,
0b00011000,
0b00011011,
0b00011000,
0b00011000,
0b00011000,
0b00000000,
// 
0b00011110,
0b00001001,
0b00001000,
0b00001110,
0b00001001,
0b00001001,
0b00010111,
0b00000000,
// 
0b00011110,
0b00001001,
0b00001001,
0b00001101,
0b00001011,
0b00001000,
0b00010100,
0b00000000};

//   .  2 , 
// ,   ,
//   
#define TR(x, y) (((x) << 2) | (y) )


// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// Place your code here
 return;//PORTC&=251; 
 }
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
    char pins = (PINB & 0xC0) >> 2;
	//   0-      ,   
	    if ((encoder_state & 16) == (pins & 16))
		return;
	//     ,    
	// 2  
	encoder_state = ((encoder_state << 2) | pins) & 0xF0;
    //  ,    ,  
	if (encoder_state == TR(0,48)&&encoder_pos>-20) encoder_pos--; 
    if (encoder_state == TR(32,16)&&encoder_pos<0) encoder_pos=0;
	if (encoder_state == TR(32,16)&&encoder_pos<31) encoder_pos++; 
    voltime=1000;
}

#define FIRST_ADC_INPUT 0
#define LAST_ADC_INPUT 1
volatile  int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
#define ADC_VREF_TYPE 0x40

// ADC interrupt service routine
// with auto input scanning
interrupt [ADC_INT] void adc_isr(void)
{
static unsigned char input_index=0;
// Read the AD conversion result
adc_data[input_index]=ADCW;
//vol[input_index]= adc_data[input_index];
// Select next ADC input
if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
   input_index=0;
ADMUX=(FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff))+input_index;
// Delay needed for the stabilization of the ADC input voltage
delay_us(1);
// Start the AD conversion
ADCSRA|=0x40;
}

// Declare your global variables here
void ssav(void)    
{if (!PIND.3)return;       
ADCSRA=0xCD;                              //ADCSRA=0xCB; 
TIMSK0=0x00;
while(1)
    {
    lcd_init(16);
    for (j=0;j<80;j++)
        {
        if(j==0) lcd_gotoxy(4,0);
        if(j<16)lcd_putchar(bukvy[j]);

        if(j==8) lcd_gotoxy(5,1);
        if(j>63){
            lcd_gotoxy(x[j-64],y[j-64]);
            lcd_putchar (32);
            }
        for(del=0; del<10000;del++)
            {if (PINB.6!=krut) 
                {voltime=1000;
                return;
                }
            if(!PIND.3)return;
           
     //       if((adc_data[0]>corr[0])||(adc_data[1]>corr[1]))return; 
              if(((adc_data[0]-corr[0])>3)||((adc_data[1]-corr[1])>3))return; 
            }      
        }
     }   
 } 
 
void adclog(void)
{       ADCSRA=0xCD;         //ADCSRA=0xCB; 
        TIMSK0=0x00;
        del=1000; 
        while(1){ 
        if (!PIND.3)return;

volcor[0]=adc_data[0]-corr[0];
volcor[1]=adc_data[1]-corr[1];
linear:  
if   (PINB.6!=krut) 
      {voltime=1000;
      return;}   

if (volcor[channel]<=3)del--; 
else del=1000;


    j=0;  
        lcd_gotoxy(0,channel);
        if(!channel) lcd_putchar(0xA7);      
        if(channel) lcd_putchar(0xA8);
//        if (j<30) {
            while ((volcor[channel]>merka[j])&&(j<30)) j++;//}
         if (j>=zamer[channel])
            {zamer[channel]=j;
            falltime[channel]=255;}
         else falltime[channel]--;
         
         if (falltime[channel]<245){
            if(zamer[channel]>0) zamer[channel]--;
            falltime[channel]=255;}
   //      if (zamer[channel]>30) zamer[channel]=30;   
         polu=(zamer[channel]&1);
         girno=(zamer[channel]>>1);
        nichego=15-girno-polu; 
        if (nichego>200) nichego=0;
        
        for(j=0;j<girno;j++)lcd_putchar (4); 
        if(polu==1)lcd_putchar(5);
        for(j=0;j<nichego;j++)lcd_putchar (3);

    channel^=1;
    if(channel==1)goto linear ;
    if (del<1)return;
     }
    }
void volu (void)
{     
        ADCSRA=0xC5;                     //  ADCSRA=0xC3;
        TIMSK0=0x01;
        lcd_init(16);
while(1){if(!PIND.3)return;
    
        if(encoder_pos>0)volume=encoder_pos; else volume=0;  
        if(encoder_pos==(-20))
            {
            #asm("cli")
            lcd_init(16);

            correctl=(adc_data[0]+1);
            delay_ms(200);
 
            correctr=(adc_data[1]+1);
            delay_ms(200); 
            corr[0]=correctl;
            corr[1]=correctr;
            for(polu=0;polu<2;polu++)
                {
                cyfh=(corr[polu]/100)|48;
                cyfm=(corr[polu]%100);
                cyfl=(cyfm%10)|48;
                cyfm=(cyfm/10)|48;  
                lcd_putchar (cyfh);
                lcd_putchar (cyfm); 
                lcd_putchar (cyfl);
                lcd_putchar (32);
                }  
            
            #asm("sei")
            delay_ms(2000);
            }
        if (vol2!=volume)
            {PORTB&=(0xE0|volume);
            delay_ms(2); 
            PORTB|=volume;
            vol2=volume;} 
        voltime--;  
        lcd_gotoxy(0,0);   
        lcd_putchar (161);  
        lcd_putchar (112); 
        lcd_putchar (111);  
        lcd_putchar (188); 
        lcd_putchar (186);  
        lcd_putchar (111); 
        lcd_putchar (99);  
        lcd_putchar (191); 
        lcd_putchar (196); 
        lcd_putchar (32);
        cyfh=(volume/10)|48;
        cyfl=(volume%10)|48;  
        lcd_putchar (cyfh); 
        lcd_putchar (cyfl);   
        lcd_gotoxy(0,1);
        polu=(volume&1);
        girno=(volume>>1);
        nichego=16-girno-polu;
        for(j=0;j<girno;j++)lcd_putchar (4); 
        if(polu==1)lcd_putchar(5);
        for(j=0;j<nichego;j++)lcd_putchar (3);
        if (voltime<0)return;
        }
}
void main(void)
{ if (volstore>31){
#asm("cli")
volstore=5;
delay_ms(100);
}
start: SMCR=0x04;
// Declare your local variables here
vol2=0;
// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=P State6=P State5=P State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0xE0;
DDRB=0x1F;

// Port C initialization
// Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State6=P State5=1 State4=0 State3=P State2=P State1=T State0=T 
PORTC=0x6C;
DDRC=0x70;    //30

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=P State2=T State1=T State0=T 
PORTD=0x08;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x03;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Falling Edge
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;     // EICRA=0x08;
EIMSK=0x02;
EIFR=0x02;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x01;

// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;

// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// USART initialization
// USART disabled
UCSR0B=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR1=0x00;

// ADC initialization
// ADC Clock frequency: 250,000 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: Free Running
// Digital input buffers on ADC0: On, ADC1: On, ADC2: Off, ADC3: Off
// ADC4: Off, ADC5: Off
DIDR0=0x3C;
ADMUX=FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff);
ADCSRA=0xEF;//ADCSRA=0xED;
ADCSRB&=0xF8;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTD Bit 0
// RD - PORTD Bit 1
// EN - PORTD Bit 2
// D4 - PORTD Bit 4
// D5 - PORTD Bit 5
// D6 - PORTD Bit 6
// D7 - PORTD Bit 7
// Characters/line: 16
corr[0]=correctl;
corr[1]=correctr;
lcd_init(16);
cyfh=0x40;
for (j=0; j<64; j++) lcd_write_byte(cyfh++,znakog[j]);
lcd_init(16);

for (j=0;j<75;j++)
    {
    if(j==0) lcd_gotoxy(4,0);
    if(j<16)lcd_putchar(bukvy[j]);

    if(j==8) lcd_gotoxy(5,1);
    if(j==60) PORTC|=16;    
    if(j==70) PORTC&=223;  
    delay_ms(100);    
    }
on=1;
for(del=0; del<18000;del++)
    {if (PINB.6!=krut) 
        {voltime=1000;
        }
     
    }      
encoder_pos=volstore; 
krut=PINB.6;
encoder_state=0xF0; 
voltime=1000; 
falltime[0]=255; 
falltime[1]=255;
zamer[1]=0;
zamer[0]=0;   
// Global enable interrupts
#asm("sei")

while (1)
      { 

      // Place your code here
    if ((on)&&(!PIND.3)&&(dela<100)) {
                
        dela++;
        delay_ms(10);
        }
        else if (dela<50) dela=0;
   
     
    if (dela>=50){
        #asm("cli")
        volstore=volume;
        delay_ms(100); 
        lcd_init(16); 
        lcd_putchar (73);  
        lcd_putchar (39); 
        lcd_putchar (108);  
        lcd_putchar (108); 
        lcd_putchar (32);  
        lcd_putchar (98); 
        lcd_putchar (101);  
        lcd_putchar (32); 
        lcd_putchar (98); 
        lcd_putchar (97); 
        lcd_putchar (99);  
        lcd_putchar (107); 
        lcd_putchar (46);  
        lcd_putchar (46); 
        lcd_putchar (46); 
        lcd_putchar (32);  
        lcd_gotoxy(0,1); 
        //for (nichego=0;nichego<16;nichego++) lcd_putchar (32);
        delay_ms(3000); 
        PORTC=0;
        PORTB=0;
        dela=0; 
        on=0;
        #asm("sei")
        lcd_init(16);
        SMCR=0x05;
        #asm("sleep")
        goto start;
        } 
    else {
        if (vol2!=volume){
        PORTB&=(0xE0|volume);
        delay_ms(7);
        PORTB|=volume;
        vol2=volume;}
        ADCSRA=0xCB;                      // ADCSRA=0xCD;
        TIMSK0=0x00;
        if (PINB.6!=krut) 
        {voltime=1000;
        krut=PINB.6;}

        if (voltime>1) volu();
  
        else 
            {        //  if ((volcor[0]<=3)&&(volcor[1]<=3)) ssav();
   //         if ((adc_data[0]<=corr[0])&&(adc_data[1]<=corr[1])) ssav(); 
            if (((adc_data[0]-corr[0])<3)&&((adc_data[1]-corr[1])<3)) ssav(); 
          else adclog();
     
//         if ((volcor[0]>3)||(volcor[1]>3)) adclog();
            }
        } 
      }
}
